import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Alley here.
 * 
 * @author (Ryan Cooke) 
 * @version (5/20/19)
 */
public class Alley extends World
{
    Ball ball = new Ball();

    /**
     * Constructor for objects of class Alley.
     */
    public Alley()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1); 
        showInstruction();
        prepare();
    }
    
    /**
     * Act Method
     */
    public void act()
    {
        showScore();
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        Pin pin = new Pin();
        addObject(pin,499,188);
        Pin pin2 = new Pin();
        addObject(pin2,522,166);
        Pin pin3 = new Pin();
        addObject(pin3,550,156);
        Pin pin4 = new Pin();
        addObject(pin4,573,140);
        Pin pin5 = new Pin();
        addObject(pin5,525,201);
        Pin pin6 = new Pin();
        addObject(pin6,549,182);
        Pin pin7 = new Pin();
        addObject(pin7,574,168);
        Pin pin8 = new Pin();
        addObject(pin8,548,215);
        Pin pin9 = new Pin();
        addObject(pin9,573,197);
        Pin pin10 = new Pin();
        addObject(pin10,573,231);
        pin5.setLocation(527,203);
        pin2.setLocation(522,166);
        pin7.setLocation(575,169);
        pin3.setLocation(551,152);
        pin.setLocation(497,176);
        pin4.setLocation(569,137);
        pin.setLocation(497,192);
        Player1 player1 = new Player1();
        addObject(player1,43,63);
        Player2 player2 = new Player2();
        addObject(player2,45,340);
        addObject(ball,84,197);
        pin2.setLocation(518,179);
        pin.setLocation(498,200);
        pin5.setLocation(523,213);
        pin6.setLocation(546,186);
        pin3.setLocation(549,160);
        pin4.setLocation(567,142);
        pin7.setLocation(572,171);
        pin4.setLocation(570,139);
        pin4.setLocation(570,135);
        pin2.setLocation(516,173);
        pin6.setLocation(551,186);
        pin3.setLocation(550,180);
        pin3.setLocation(547,133);
        pin2.setLocation(519,151);
        pin2.setLocation(524,188);
        pin3.setLocation(549,174);
        pin4.setLocation(572,154);
        pin2.setLocation(521,173);
        pin3.setLocation(547,149);
        pin3.setLocation(545,155);
        pin3.setLocation(550,159);
        pin4.setLocation(572,129);
        pin4.setLocation(572,153);
        pin4.setLocation(570,138);
    }
    
    /**
     * Add instruction for game.
     */
    public void showInstruction()
    {
        showText("Ball: Hold B to Hit Pins, <, > to move up and down",370, 100);
        showText("Player One(Blue): Arrow Keys", 460, 50);
        showText("Player Two(Green): WASD", 475, 75);
        showText("Reset World to Reset Pins", 470, 300);
    }
    
    /**
     * Show Score.
     */
    public void showScore()
    {
        showText("Score: " + ball.score, 150, 25);
    }
}
